#include	"ti83plus.inc"			
#include	"mirage.inc"
	.org	$9d93			
	.db	$BB,$6D	
	ret
	.db	1
	.db	%00000000,%00000000		
	.db	%01000011,%11000010
	.db	%00100100,%00100100
	.db	%00001000,%00010000
	.db	%00010010,%01001000
	.db	%11010101,%10101011
	.db	%00010010,%01001000
	.db	%00001010,%01010000
	.db	%00100101,%10100100
	.db	%01000011,%11000010
	.db	%00000011,%11000000
	.db	%00000011,%11000000
	.db	%00000011,%11000000
	.db	%00000001,%10000000
	.db	%00000000,%00000000
	.db	"Blackout - J. Panetta",0
 #define astore appbackupscreen ;stores a for later use
 #define boardrow astore + 1; keep track of current row
 #define boardloc boardrow + 2 ;keeps track of loc on board
 #define cursorpos boardloc + 2; keeps track of cursor on screen
 #define cursorfake cursorpos + 2; keeps track of "fake" cursor position
 #define linebuffer cursorfake + 2; used for temporary storage of 1 byte
 #define plotscreenloc linebuffer + 1;used to keep track of loc on screen
 #define imageloc plotscreenloc + 2
 #define menupos imageloc + 2 ;stores where the hilight should be placed on menu
 #define selecteditem menupos + 2 ;stores which item to execute after menu
 bcall(_clrlcdfull)
 bcall(_grbufclr)
 set textEraseBelow, (IY + textFlags)
 set bufferOnly, (IY + plotFlag3)
 set textWrite, (IY + sGrFlags) ;only write text to buffer
 call copysidebar
 ld hl, bltitle
 ld de, 0d
 ld (pencol), de
 ld de, 10d
 ld (penrow), de
 bcall(_vputs) ;automatically increments hl for us so we dont have to set it
 ld de, 4d
 ld (pencol), de
 ld de, 18d
 ld (penrow), de
 bcall(_vputs)
 ld de, 5d
 ld (pencol), de
 ld de, 34d
 ld (penrow), de
 bcall(_vputs)
 ld de, 4d
 ld (pencol), de
 ld de, 42d
 ld (penrow), de
 bcall(_vputs)
 ld de, plotsscreen + 408
 ld (menupos), de
 ld a, %00000000
 ld (selecteditem), a
 ld b, 7
 ld hl, (menupos)
 call highlightitem
menuloop:
 bcall(_grbufcpy)
 call waitforkey
 cp skup
 jp z, highlightup
 cp skdown
 jp z, highlightdown
 cp skenter
 jp z, executeselection
 cp skclear
 ret z ;quit
 cp skmode
 ret z ;quit
 jp menuloop
highlightitem: ;highlights an item on the menu at the starting pos of menupos
 push bc 
 ld b, 5
 call invrow
 pop bc
 djnz highlightitem
 ret
invrow: ;inverts one for on the menu
 ld a, (hl)
 ld d, %11111111
 xor d ;invert what ever is in a
 ld (hl), a
 inc hl
 djnz invrow ;keep doing this across the screen
 ld de, 7
 add hl, de ;move down to the start of the next row
 ret
highlightup:
 ld b, 7 ;7 rows to highlight
 ld hl, (menupos)
 call highlightitem ;unhighlight the current selection
 ld de, plotsscreen + 408 ;location of first item (34 * 12)
 ld (menupos), de
 ld hl, (menupos)
 ld b, 7 ;7 rows
 call highlightitem ;highlight that
 ld a, %00000000
 ld (selecteditem), a ;store which item is selected
 jp menuloop ;return
highlightdown:
 ld b, 7 ;7 rows again
 ld hl, (menupos)
 call highlightitem ;unhilight the current selection
 ld de, plotsscreen + 504 ;location of second item (42 * 12)
 ld (menupos), de
 ld hl, (menupos)
 ld b, 7 ;7 more rows
 call highlightitem ;highlight that
 ld a, %00000001
 ld (selecteditem), a
 jp menuloop
executeselection:
 ld a, (selecteditem)
 cp 0d
 jp z, startnewgame
 cp 1d
 jp z, startsavedgame ;don't really need this line...
startsavedgame:
 bcall(_grbufclr)
 call copysidebar
 call copylevelbox
 call writelevel
 ld hl, startbcursor
 ld de, bitcursor
 ld bc, 6
 ldir ;copy the starting cursor into the current cursor
 ld hl, plotSScreen
 ld (cursorpos), hl
 ld hl, cursorfake
 ld (hl), 0
 inc hl
 ld (hl), 0
 jp gameloop
 ret
startnewgame:
 bcall(_grbufclr)
 call copysidebar
 call copylevelbox
 ld hl, level1
 ld (clevadress), hl
 ld de, clevel
 ld bc, 5
 ldir ;copy the level on to the current "board" or level
 ld a, %00000001
 ld (clevnum), a
 ld hl, startbcursor
 ld de, bitcursor
 ld bc, 6
 ldir ;copy the starting cursor into the current cursor
 call drawinit ;draw the board
 call writelevel
 ld hl, plotSScreen
 ld (cursorpos), hl
 ld hl, cursorfake
 ld (hl), 0
 inc hl
 ld (hl), 0
 jp gameloop
 ret
copysidebar:
 ld hl, sidebar
 ld (imageloc), hl
 ld hl, plotSScreen+5
 ld (plotscreenloc), hl
 ld b, 64
copybarloop:
 push bc
 ld hl, (imageloc)
 ld de, (plotscreenloc)
 ld bc, 7
 ldir
 ld hl, (plotscreenloc)
 ld de, 12
 add hl, de
 ld (plotscreenloc), hl
 ld hl, (imageloc)
 ld de, 7
 add hl, de
 ld (imageloc), hl
 pop bc
 djnz copybarloop
 ret
copylevelbox:
 ld hl, levelbox
 ld (imageloc), hl
 ld hl, plotsscreen+504
 ld (plotscreenloc), hl
 ld b, 20
copyboxloop:
 push bc
 ld hl, (imageloc)
 ld de, (plotscreenloc)
 ld bc, 5
 ldir
 ld hl, (plotscreenloc)
 ld de, 12
 add hl, de
 ld (plotscreenloc), hl
 ld hl, (imageloc)
 ld de, 5
 add hl, de
 ld (imageloc), hl
 pop bc
 djnz copyboxloop
 ret
writelevel: ;writes the level number. Level nums are 1 byte numbers
 ld a, (clevnum)
 bcall(_setxxop1)
 ld de, 19d
 ld (pencol), de
 ld de, 54d
 ld (penrow), de
 bcall(_dispop1a)
 ret
;*--------------------Board drawing code-----------------------*
;| Draws a 5*5 array of lights. It works, too                  |
;*-------------------------------------------------------------*
drawinit:
 ld de, plotSScreen
 ld (boardloc), de
 ld ix, clevel
 ld (boardrow), ix
 ld b, 5
drawboard:
 push bc
 xor a
 ld ix, (boardrow)
 ld a, (ix) ;get row on board
 inc ix ;move down a row
 ld (boardrow), ix
 ld (astore), a
 bit 7, a
 call nz, putlight
 ld a, (astore)
 bit 7, a
 call z, putlightoff
 ld a, (astore)
 bit 6, a
 call nz, putlight
 ld a, (astore)
 bit 6, a
 call z, putlightoff
 ld a, (astore)
 bit 5, a
 call nz, putlight
 ld a, (astore)
 bit 5, a
 call z, putlightoff
 ld a, (astore)
 bit 4, a
 call nz, putlight
 ld a, (astore)
 bit 4, a
 call z, putlightoff
 ld a, (astore)
 bit 3, a
 call nz, putlight
 ld a, (astore)
 bit 3, a
 call z, putlightoff
 ld hl, (boardloc)
 ld de, 91 ;move down 8 rows...
 add hl, de
 ld (boardloc), hl
 pop bc
 djnz drawboard
 ret
putlight:
 ld hl, (boardloc)
 ld ix, lighton
 ld b, 8 ;going to copy 8 rows
 call copyimage
 ld hl, boardloc
 inc (hl)
 ret
putlightoff:
 ld hl, (boardloc)
 ld ix, lightoff
 ld b, 8
 call copyimage
 ld hl, boardloc
 inc (hl)
 ret
copyimage:
 push bc
 ld a, (ix)
 ld (hl), a ;copy the row
 inc ix ;move down a row on image
 ld de, 12
 add hl, de ;move down a row on screen
 pop bc
 djnz copyimage ;keep on copyin' till da end
 ret
;////////////////// end board drawing code ///////////////////////
;*-------------------Cursor drawing code--------------------*
;|Draws the cursor at the points in the cursorpos memory adr|
;*----------------------------------------------------------*
xorimage:
 push bc
 ld d, (ix)
 ld a, (hl)
 xor d
 ld (hl), a ;copy row
 inc ix ;move down a row on image
 ld de, 12
 add hl, de ;move down a row on screen
 pop bc
 djnz xorimage ;keep on copyin' till da end
 ret
putcursor:
 ld hl, (cursorpos)
 ld ix, cursor
 ld b, 8
 call xorimage
 ret
;//////////////////end cursor drawing code//////////////////////
;*---------------------"bit cursor" movement code--------------*
;|This code handles the movement of the data that determines   |
;|which lights on the board are to be turned off.              |
;*-------------------------------------------------------------*
rotaterightcursor:
 ld a, (hl)
 rrca
 ld (hl), a
 inc hl
 djnz rotaterightcursor
 ret
rotateleftcursor:
 ld a, (hl)
 rlca
 ld (hl), a
 inc hl
 djnz rotateleftcursor
 ret
rotatedowncursor:
 ld a, (bitcursor + 5)
 ld (linebuffer), a
 ld hl, bitcursor
 ld de, cursorbuffer
 ld bc, 6
 ldir ;copy everything to the buffer
 ld hl, cursorbuffer
 ld de, bitcursor+1
 ld bc, 5
 ldir ;move everything down
 ld a, (linebuffer)
 ld (bitcursor), a ;finally, copy what used to be last up to the top...
 ret
rotateupcursor:
 ld a, (bitcursor)
 ld (linebuffer), a
 ld hl, bitcursor + 1
 ld de, bitcursor
 ld bc, 5
 ldir ;move everything up
 ld a, (linebuffer)
 ld (bitcursor + 5), a ;copy what used to be first to the very bottom
 ret
;//////////////////end "bit cursor" movement code/////////////////
;*------------------------Level Loading code-------------------*
;|This code will load the next level then return to the game   |
;*-------------------------------------------------------------*
nextlevel:
 ld de, (clevnum)
 inc de
 ld (clevnum), de
 ld hl, (clevadress)
 ld de, 5
 add hl, de
 ld (clevadress), hl
 ld de, clevel
 ld bc, 5
 ldir ;load the level into clev
 ret ;return to game
resetlevel: ; this statement is not called, but jumped to... don't use ret statement
 ld hl, (clevadress)
 ld de, clevel
 ld bc, 5
 ldir
 jp gameloop ;return to game
;////////////////////end level loading code/////////////////////
;*-----------------------Winner testing code-------------------*
;|This checks to see if all of the lights have been turned off |
;*-------------------------------------------------------------*
testifwon:
 ld hl, clevel
 ld b, 5
testloop:
 ld a, (hl)
 ld d, %11111000
 and d ;we don't wanna have to add the last three bits, so clear them
 cp 0d ;if a is zero then there are no lights on the row!
 ret nz ;we can quit testing and return to the game whenever we hit lights on
 inc hl ;move down a row
 djnz testloop ;test the next row
 ld de, 3d
 ld (pencol), de
 ld de, 17d
 ld (penrow), de
 set textInverse, (IY + textFlags)
 ld hl, beatlevtext
 bcall(_vputs)
 bcall(_grbufcpy)
 res textInverse, (IY + textFlags)
 bcall(_getkey)
 call nextlevel
 call writelevel
 ret
;/////////////////end winner testing code////////////////////////
winscreen: ;to be run when the player beats 20 levels
 ld hl, winimage
 ld de, plotSScreen
 ld bc, 768
 ldir ;copy the image
 bcall(_grbufcpy) ;display the screen
 call waitforkey ;wait for a key press
 ld hl, level1 ;now, reset all of the program to its pre-run state
 ld (clevadress), hl
 ld de, clevel
 ld bc, 5
 ldir ;copy the level on to the current "board" or level
 ld a, %00000001
 ld (clevnum), a
 ld hl, startbcursor
 ld de, bitcursor
 ld bc, 6
 ldir ;copy the starting cursor into the current cursor
 ret ;quit game
;*---------------------Keypress handling code------------------*
;|This code handles what to do when the dirrectional keys are  |
;|pressed and when the enter/2nd key is pressed                |
;*-------------------------------------------------------------*
moveleft:
 ld a, (cursorfake)
 cp 0
 jp z, gameloop
 dec a
 ld (cursorfake), a
 ld hl, (cursorpos)
 dec hl
 ld (cursorpos), hl
 ld hl, bitcursor
 ld b, 6
 call rotateleftcursor
 jp gameloop
moveright:
 ld a, (cursorfake)
 cp 4
 jp z, gameloop
 inc a
 ld (cursorfake), a
 ld hl, (cursorpos)
 inc hl
 ld (cursorpos), hl
 ld hl, bitcursor
 ld b, 6
 call rotaterightcursor
 jp gameloop
movedown:
 ld a, (cursorfake + 1) ;y value
 cp 4
 jp z, gameloop
 inc a
 ld (cursorfake + 1), a
 ld hl, (cursorpos) ;y value
 ld de, 96 ;8*12
 add hl, de
 ld (cursorpos), hl ;store that
 call rotatedowncursor ;move the bit cursor down
 jp gameloop
moveup:
 ld a, (cursorfake + 1) ;y value
 cp 0
 jp z, gameloop
 dec a
 ld (cursorfake + 1), a
 ld hl, (cursorpos)
 scf ;set carry flag
 ld de, 95
 sbc hl, de
 ld (cursorpos), hl ;store that
 call rotateupcursor ;move the bit cursor up
 jp gameloop
changelight: ;the code for changing the lights
 ld b, 5
 ld hl, clevel
 ld ix, bitcursor
changeloop:
 ld a, (hl)
 ld d, (ix)
 xor d ;toggle the lights where there is a 1 in the bit cursor
 ld (hl), a
 inc hl
 inc ix
 djnz changeloop
 call drawinit ;draw board before checking if won - makes it look better
 call testifwon ;check if the player has beaten the level
 ld a, (clevnum) ;test if the player has beathen all of the levels. This is
 cp 21d ;inefficient to run every time, but its its short enough and I'm lazy
 jp z, winscreen ;if they have reached level 21, go to the win screen and quit
 jp gameloop ;now return and redraw
waitforkey:
 bcall(_getcsc)
 cp 0
 jp z, waitforkey
 ret
;///////////////end keypress handling code/////////////////////
gameloop:
 call drawinit
 call putcursor
 bcall(_grbufcpy)
 call waitforkey
 cp skclear
 jp z, quit
 cp skmode
 jp z, quit
 cp skleft
 jp z, moveleft
 cp skright
 jp z, moveright
 cp skup
 jp z, moveup
 cp skdown
 jp z, movedown
 cp sk2nd
 jp z, changelight
 cp skenter
 jp z, changelight
 cp skdel
 jp z, resetlevel
 jp gameloop
quit:
 ret
bltitle:
 .db "Blackout 1.0",0
author:
 .db "J. Panetta", 0
ngtext:
 .db "New Game", 0
svtext:
 .db "Load Game", 0
beatlevtext:
 .db "Great Job!", 0
lighton: ;8 byte sprite
 .db %00000000
 .db %00111000
 .db %01000100
 .db %10000010
 .db %10000010
 .db %10000010
 .db %01000100
 .db %00111000
lightoff: ;8 byte sprite
 .db %00000000
 .db %00111000
 .db %01111100
 .db %11111110
 .db %11111110
 .db %11111110
 .db %01111100
 .db %00111000
cursor: ;8 byte sprite
 .db %00000000
 .db %10000010
 .db %00000000
 .db %00010000
 .db %00111000
 .db %00010000
 .db %00000000
 .db %10000010
bitcursor: ;current position of what to invert on the board
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000 ;this is a buffer line
cursorbuffer: ;used when moving cursor down
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
startbcursor: ;starting position of what to invert on the board 6 bytes
 .db %11000001
 .db %10000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %10000000 ;this is a buffer line
clevel: ;5 bytes. The level that the player is currently playing
 .db %00011000
 .db %01101000
 .db %10010000
 .db %01101000
 .db %00011000
clevnum: ;holds the current level you are on
 .db %00000001
clevadress: ;2 byte address to current level in ram
 .dw level1 ;we wan't to start with it pointing to level 1
level1: ;5 bytes. First 5 bits of each byte are the 5 ligts in the row
 .db %00011000
 .db %01101000
 .db %10010000
 .db %01101000
 .db %00011000
level2:
 .db %11011000
 .db %11011000
 .db %11011000
 .db %11011000
 .db %11011000
level3:
 .db %11011000
 .db %11111000
 .db %10101000
 .db %11111000
 .db %11011000
level4:
 .db %01010000
 .db %11011000
 .db %00000000
 .db %11011000
 .db %01010000
level5:
 .db %10101000
 .db %11111000
 .db %11011000
 .db %11111000
 .db %10101000
level6:
 .db %11111000
 .db %01110000
 .db %11111000
 .db %10101000
 .db %01110000
level7:
 .db %11111000
 .db %11111000
 .db %11011000
 .db %11111000
 .db %11111000
level8:
 .db %10101000
 .db %10101000
 .db %01010000
 .db %10101000
 .db %10101000
level9:
 .db %11111000
 .db %11011000
 .db %01010000
 .db %00000000
 .db %01110000
level10:
 .db %01010000
 .db %01110000
 .db %01010000
 .db %11111000
 .db %00000000
level11:
 .db %10111000
 .db %10001000
 .db %00010000
 .db %11001000
 .db %11011000
level12:
 .db %10101000
 .db %01010000
 .db %10101000
 .db %01010000
 .db %10101000
level13:
 .db %11111000
 .db %11111000
 .db %11111000
 .db %11111000
 .db %11111000
level14:
 .db %11011000
 .db %11011000
 .db %00100000
 .db %11011000
 .db %11011000
level15:
 .db %00100000
 .db %01010000
 .db %10101000
 .db %01010000
 .db %00100000
level16:
 .db %00000000
 .db %00100000
 .db %01110000
 .db %11111000
 .db %00000000
level17:
 .db %01110000
 .db %11111000
 .db %11111000
 .db %11111000
 .db %01110000
level18:
 .db %01100000
 .db %10010000
 .db %10010000
 .db %01100000
 .db %01100000
level19:
 .db %01110000
 .db %11011000
 .db %10001000
 .db %00000000
 .db %01110000
level20:
 .db %11011000
 .db %10001000
 .db %11011000
 .db %10001000
 .db %11011000
sidebar: ;big 54*64 image - 448 bytes
	.db %00100111,%11111111,%11111111,%11110000,%00000000,%00000000,%00000111
	.db %00011111,%11111111,%11111111,%11110000,%00000000,%00000000,%00000001
	.db %01111111,%11111111,%11111111,%11110000,%00000000,%00000000,%00000111
	.db %00011111,%11000011,%11111111,%11110000,%00000000,%00111100,%00011011
	.db %00100111,%10111101,%11111111,%11110000,%00000000,%01000010,%00000111
	.db %00011111,%01100110,%11111111,%11110000,%00000000,%10011001,%00000001
	.db %01111111,%01011010,%11111111,%11110000,%00000000,%10100101,%00000111
	.db %00011111,%01100110,%11111111,%11110000,%00000000,%10011001,%00011011
	.db %00100111,%10100101,%11111000,%11110000,%00000000,%01011010,%00000111
	.db %00011111,%11000011,%11111011,%01110000,%00000000,%00111100,%00000001
	.db %01111111,%11000011,%11111011,%01110000,%00000000,%00111100,%00000111
	.db %00011111,%11000011,%11111000,%11110000,%00000000,%00111100,%00011011
	.db %00100111,%11100111,%11111011,%01110000,%00000000,%00011000,%00000111
	.db %00011111,%11111111,%11110111,%01110000,%00000000,%00000000,%00000001
	.db %01111111,%11111111,%11100000,%11110000,%00000000,%00000000,%00000111
	.db %00011111,%11111111,%11111111,%11110000,%00000000,%00000000,%00011011
	.db %00100111,%11111111,%11111111,%11110000,%00000000,%00000000,%00000111
	.db %00011111,%11111111,%11111111,%11110000,%00000000,%00000000,%00000001
	.db %01111111,%11111111,%11111000,%11110000,%00000000,%00000000,%00000111
	.db %00011111,%11000011,%11111001,%11110000,%11100000,%00111100,%00011011
	.db %00100111,%10111101,%11111011,%11110001,%00010000,%01000010,%00000111
	.db %00011111,%01100110,%11111011,%11110001,%00010000,%10011001,%00000001
	.db %01111111,%01011010,%11111011,%11110010,%00010000,%10100101,%00000111
	.db %00011111,%01100110,%11110110,%11110010,%00100000,%10011001,%00011011
	.db %00100111,%10100101,%11100001,%11110010,%00100000,%01011010,%00000111
	.db %00011111,%11000011,%11111111,%11110001,%11000000,%00111100,%00000001
	.db %01111111,%11000011,%11111111,%11110000,%00000000,%00111100,%00000111
	.db %00011111,%11000011,%11111111,%11110000,%00000000,%00111100,%00011011
	.db %00100111,%11100111,%11111110,%11110000,%00000000,%00011000,%00000111
	.db %00011111,%11111111,%11111100,%11110011,%10111000,%00000000,%00000001
	.db %01111111,%11111111,%11111010,%11110001,%00010000,%00000000,%00000111
	.db %00011111,%11111111,%11111010,%11110010,%00100000,%00000000,%00011011
	.db %00100111,%11111111,%11110000,%11110010,%00100000,%00000000,%00000111
	.db %00011111,%11111111,%11110110,%11110010,%00100000,%00000000,%00000001
	.db %01111111,%11111111,%11100100,%01110010,%01000000,%00000000,%00000111
	.db %00011111,%11000011,%11111111,%11110011,%10000000,%00111100,%00011011
	.db %00100111,%10111101,%11111111,%11110000,%00000000,%01000010,%00000111
	.db %00011111,%01100110,%11111111,%11110000,%00000000,%10011001,%00000001
	.db %01111111,%01011010,%11111100,%10110000,%00000000,%10100101,%00000111
	.db %00011111,%01100110,%11111011,%00110011,%11100000,%10011001,%00011011
	.db %00100111,%10100101,%11110111,%10110010,%10100000,%01011010,%00000111
	.db %00011111,%11000011,%11110111,%11110001,%00000000,%00111100,%00000001
	.db %01111111,%11000011,%11110111,%11110001,%00000000,%00111100,%00000111
	.db %00011111,%11000011,%11110111,%01110001,%00000000,%00111100,%00011011
	.db %00100111,%11100111,%11111000,%11110010,%00000000,%00011000,%00000111
	.db %00011111,%11111111,%11111111,%11110111,%00000000,%00000000,%00000001
	.db %01111111,%11111111,%11111111,%11110000,%00000000,%00000000,%00000111
	.db %00011111,%11111111,%11111111,%11110000,%00000000,%00000000,%00011011
	.db %00100111,%11111111,%11111001,%00110000,%00000000,%00000000,%00000111
	.db %00011111,%11111111,%11111001,%01110000,%00000000,%00000000,%00000001
	.db %01111111,%11111111,%11111010,%11110000,%00000000,%00000000,%00000111
	.db %00011111,%11000011,%11111001,%11110000,%00000000,%00111100,%00011011
	.db %00100111,%10111101,%11111001,%11110000,%00000000,%01000010,%00000111
	.db %00011111,%01100110,%11110110,%11110000,%00000000,%10011001,%00000001
	.db %01111111,%01011010,%11100010,%01110000,%00000000,%10100101,%00000111
	.db %00011111,%01100110,%11111111,%11110000,%00000000,%10011001,%00011011
	.db %00100111,%10100101,%11111111,%11110000,%00000000,%01011010,%00000111
	.db %00011111,%11000011,%11111111,%11110000,%00000000,%00111100,%00000001
	.db %01111111,%11000011,%11111111,%11110000,%00000000,%00111100,%00000111
	.db %00011111,%11000011,%11111111,%11110010,%00010000,%00111100,%00011011
	.db %00100111,%11100111,%11111101,%01110110,%00101000,%00011000,%00000111
	.db %00011111,%11111111,%11111101,%01110010,%00101000,%00000000,%00000001
	.db %01111111,%11111111,%11111110,%11010010,%10010000,%00000000,%00000111
	.db %00011111,%11111111,%11111111,%11110000,%00000000,%00000000,%00011011
levelbox: ;100 bytes exactly!
	.db %00011111,%11111111,%11111111,%11111111,%11111000
	.db %01101011,%00000000,%00000000,%00000000,%11010110
	.db %01010101,%00001110,%00000000,%00001100,%10101010
	.db %10101011,%00001100,%00000000,%00000100,%11010101
	.db %11010101,%00001000,%01111010,%01101000,%10101011
	.db %10101011,%00001000,%10101010,%10101000,%11010101
	.db %11010101,%00001001,%11001101,%11001000,%10101011
	.db %10101011,%00010011,%00001101,%00010100,%11010101
	.db %11010101,%00111101,%11001001,%11011000,%10101011
	.db %10101011,%00000000,%00000000,%00000000,%11010101
	.db %11010101,%00111111,%11111111,%11111100,%10101011
	.db %10101011,%00000000,%00000000,%00000000,%11010101
	.db %11010101,%00000000,%00000000,%00000000,%10101011
	.db %10101011,%00000000,%00000000,%00000000,%11010101
	.db %11010101,%00000000,%00000000,%00000000,%10101011
	.db %10101011,%00000000,%00000000,%00000000,%11010101
	.db %11010101,%00000000,%00000000,%00000000,%10101011
	.db %01101011,%00000000,%00000000,%00000000,%11010110
	.db %01110101,%00000000,%00000000,%00000000,%10101110
	.db %00011111,%11111111,%11111111,%11111111,%11111000
winimage: ;768 byte image
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000011,%11111111
	.db %11111111,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,%11111111
	.db %11111110,%00111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111000,%11111111
	.db %11111100,%01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111100,%01111111
	.db %11111100,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110,%01111111
	.db %11111100,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110,%01111111
	.db %11111100,%11111100,%10111111,%11111111,%11111111,%11110011,%11110011,%11111110,%11111111,%11111111,%11011110,%01111111
	.db %11111100,%11111011,%00111111,%11111111,%11111111,%11111011,%11111011,%11110111,%11111111,%11111111,%11011110,%01111111
	.db %11111100,%11110111,%10100100,%10111000,%00101100,%11100110,%10110111,%00100000,%11100100,%10110011,%11011110,%01111111
	.db %11111100,%11110111,%11010110,%00110101,%10011010,%11010110,%10110110,%10110110,%11010110,%00110111,%10111110,%01111111
	.db %11111100,%11110111,%10110110,%10110001,%10110110,%10110110,%10110101,%10110110,%10110110,%10111011,%10111110,%01111111
	.db %11111100,%11110111,%00101101,%01110111,%01110101,%10101101,%01101001,%01101101,%10101101,%01111011,%11111110,%01111111
	.db %11111100,%11111000,%10011101,%00110011,%01110000,%00000100,%00100100,%00000100,%10011101,%00100111,%01111110,%01111111
	.db %11111100,%11111111,%11111111,%11101101,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110,%01111111
	.db %11111100,%11111111,%11111111,%11100011,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110,%01111111
	.db %11111100,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110,%01111111
	.db %11111100,%01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111100,%01111111
	.db %11111110,%00111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111000,%11111111
	.db %11111111,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000001,%11111111
	.db %11111111,%10000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000011,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%11111100,%00001111,%11111111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%11100011,%11110001,%11111111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%11001111,%11111100,%11111111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%10111111,%11111111,%01111111,%11111111,%11111111,%11111111,%11111111
	.db %11011011,%11111111,%11110111,%11111111,%11111111,%01111111,%11111111,%10111111,%11110111,%11111111,%11011111,%11111111
	.db %10010000,%01011011,%11100011,%00010110,%10001110,%11111111,%11111111,%11011111,%11100011,%00011001,%00011100,%10100111
	.db %11001101,%10011011,%11100101,%11100110,%10110110,%11111111,%11111111,%11011111,%11100100,%11011110,%10111011,%00010111
	.db %11011011,%00110111,%11011010,%00000101,%00001101,%11111111,%11111111,%11101111,%11011010,%00000001,%01100000,%10110111
	.db %10111001,%10010111,%11011010,%00110111,%00111101,%11111111,%11111111,%11101111,%10000110,%01100011,%00110001,%01101111
	.db %11111111,%11111111,%11111111,%11111111,%11111101,%11111111,%11111111,%11101111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111101,%11111111,%11111111,%11101111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11111001,%11011111,%11111111,%00111101,%11111111,%11111111,%11101111,%01110111,%11111111,%11111111,%11111111
	.db %11111111,%00111001,%11011111,%11001100,%10111101,%11111010,%10101111,%11101100,%01100011,%00011111,%11111111,%11111111
	.db %11111111,%11011011,%11011111,%10110100,%11111101,%11110101,%01010111,%11101110,%11100100,%11011111,%11111111,%11111111
	.db %11111100,%00110111,%10111111,%01101101,%11111110,%11110011,%11100111,%11011101,%10011010,%00011111,%11111111,%11111111
	.db %11111100,%00100110,%00111111,%00011011,%11111110,%11111001,%11001111,%11011100,%10110110,%01111111,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%01111100,%10011111,%10111111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%10111110,%10111111,%01111111,%11111111,%11111111,%11111111,%11111111
	.db %11101111,%11111111,%11111011,%11111111,%11101111,%11001110,%10111100,%11111111,%01110111,%11011111,%11111111,%11111111
	.db %11101100,%01011010,%00111011,%00011111,%10011010,%01100010,%00110001,%11111110,%01100001,%10111000,%11111111,%11111111
	.db %11101101,%10011010,%11011011,%01111111,%11011001,%01111000,%00000111,%11111111,%01100101,%10110111,%11111111,%11111111
	.db %11011000,%00010100,%00110111,%00011111,%10110111,%01111000,%11000111,%11111110,%10101101,%10110000,%11111111,%11111111
	.db %00011001,%11011100,%11000100,%01111111,%00110110,%11111011,%00000111,%11111110,%01011010,%00100011,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%11111000,%00110111,%11111111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%11111000,%11000111,%11111111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11111111,%10111111,%11111111,%11111111,%01111011,%00000111,%11100001,%01111111,%11111111,%11111111,%11111111
	.db %11111101,%01100011,%10110001,%10011000,%11001110,%01111000,%00110111,%11001100,%01110010,%01001111,%11111111,%11111111
	.db %11111100,%10101101,%10110110,%11101011,%10110110,%11111000,%11000111,%11100110,%11111100,%11011111,%11111111,%11111111
	.db %11111011,%11000011,%01100000,%00011000,%00001101,%11111011,%00000111,%11110101,%10000010,%00011111,%11111111,%11111111
	.db %11111011,%11001100,%01100110,%00000011,%00011101,%11111100,%00001111,%00001100,%11000110,%01111111,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%11111110,%00011111,%11111111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
	.db %11111111,%11011111,%11111111,%11111101,%11111001,%11111111,%11111111,%11111111,%11011111,%10111111,%11111110,%11111111
	.db %11111111,%00011011,%00101100,%01100001,%11110010,%00010101,%11111011,%01000010,%00010010,%00111001,%10001100,%11111111
	.db %11111111,%10111011,%00010101,%10010011,%11100011,%01100010,%11111011,%01011001,%10111101,%01110110,%01111101,%11111111
	.db %11111111,%01010100,%01101000,%00110111,%11101110,%11001111,%11111010,%00001101,%10000010,%11000001,%00001101,%11111111
	.db %11111111,%00110001,%01101001,%10000111,%11011110,%01101111,%11111010,%01111100,%01000110,%01100010,%00111011,%11111111
	.db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111

.end					;End of code